#include "UE.h"

// IveBJt[
void UE::OF(IplImage *capture_Image,IplImage *before_Image,CvRect mouth,CvRect mouth_before)
{
	//************************************ ϐ錾 **************************************************
	IplImage *mouthImage_gray, *before_mouthImage_gray; // EOt[̌摜
	IplImage *mouthImage_gray2, *before_mouthImage_gray2; // EOt[̌摜i摜TCYߌj
	int i, j, dx, dy, rows, cols; // JE^CExNgCcEubN
	int block_size = 5; // rΏۂƂȂ{ubÑTCY
	int shift_size = 1; // ubNW̑
	CvMat *velx, *vely; // IveBJt[̐C
	CvSize block = cvSize (block_size, block_size); // rΏۂƂȂ{ubÑTCY
	CvSize shift = cvSize (shift_size, shift_size); // ubNW̑
	CvSize max_range = cvSize (50, 50); // ΏۂƂȂubN̋ߖT̈
	//************************************************************************************************

	// ö؂
	cvSetImageROI(capture_Image, mouth);
	cvSetImageROI(before_Image, mouth_before);

	// wb_̍쐬ƃf[^̈̊m
	mouthImage_gray = cvCreateImage(cvSize(mouth.width, mouth.height), IPL_DEPTH_8U, 1);
	before_mouthImage_gray = cvCreateImage(cvSize(mouth_before.width, mouth_before.height), IPL_DEPTH_8U, 1);

	// 摜̃O[XP[
	cvCvtColor(capture_Image, mouthImage_gray, CV_BGR2GRAY);
	cvCvtColor(before_Image, before_mouthImage_gray, CV_BGR2GRAY);

	// ق̉摜TCYɍ킹
	if(mouth.width * mouth.height < mouth_before.width * mouth_before.height){
		// wb_̍쐬ƃf[^̈̊m
		mouthImage_gray2 = cvCreateImage(cvSize(mouth.width, mouth.height), IPL_DEPTH_8U, 1);
		before_mouthImage_gray2 = cvCreateImage(cvSize(mouth.width, mouth.height), IPL_DEPTH_8U, 1);

		// 摜̃Rs[
		cvCopy(mouthImage_gray, mouthImage_gray2, NULL);
		// oCL[rbN@ɂ鍂𑜓x
		cvResize(before_mouthImage_gray, before_mouthImage_gray2, CV_INTER_CUBIC);

	}else{
		// wb_̍쐬ƃf[^̈̊m
		mouthImage_gray2 = cvCreateImage(cvSize(mouth_before.width, mouth_before.height), IPL_DEPTH_8U, 1);
		before_mouthImage_gray2 = cvCreateImage(cvSize(mouth_before.width, mouth_before.height), IPL_DEPTH_8U, 1);

		// 摜̃Rs[
		cvCopy(before_mouthImage_gray, before_mouthImage_gray2, NULL);
		// oCL[rbN@ɂ鍂𑜓x
		cvResize(mouthImage_gray, mouthImage_gray2, CV_INTER_CUBIC);
	}

	// xxNgi[\̂̊m
	rows = int (ceil (double (mouthImage_gray2->height) / block_size));
	cols = int (ceil (double (mouthImage_gray2->width) / block_size));
	velx = cvCreateMat (rows, cols, CV_32FC1);
	vely = cvCreateMat (rows, cols, CV_32FC1);
	cvSetZero (velx);
	cvSetZero (vely);

	// qXgŐψꉻ
	cvEqualizeHist(mouthImage_gray2, mouthImage_gray2);
	cvEqualizeHist(before_mouthImage_gray2, before_mouthImage_gray2);

	// IveBJt[̌vZ
	cvCalcOpticalFlowBM (mouthImage_gray2, before_mouthImage_gray2, block, shift, max_range, 0, velx, vely);

	// vZꂽt[`
	for (i = 0; i < velx->width; i++) {
		for (j = 0; j < vely->height; j++) {
			// ΏۃubN̈ړ
			dx = (int) cvGetReal2D (velx, j, i);
			dy = (int) cvGetReal2D (vely, j, i);
			// IveBJt[`
			//cvLine (mouthImage_gray2, cvPoint (i * block_size, j * block_size),
			//	cvPoint (i * block_size + dx, j * block_size + dy), CV_RGB (255, 0, 0), 1, CV_AA, 0);
			of[0] += sqrt(pow((double)dx,(double)2) + (double)pow((double)dy,(double)2)); // xNg̑傫̑a
		}
	}

	// Ki摜TCYŊj
	of[0] /= (mouthImage_gray2->height * mouthImage_gray2->width);

	cvResetImageROI(capture_Image); // ROÏ̉
	cvResetImageROI(before_Image);
}

// Βla
void UE::SAD(IplImage *capture_Image,IplImage *before_Image,CvRect mouth,CvRect mouth_before)
{
	//************************************ ϐ錾 **************************************************
	IplImage *mouthImage_gray, *before_mouthImage_gray; // EOt[̌摜
	IplImage *mouthImage_gray2, *before_mouthImage_gray2; // EOt[̌摜i摜TCYߌj
	int x, y; // for̃JE^
	//************************************************************************************************ 

	// ö؂
	cvSetImageROI(capture_Image, mouth);
	cvSetImageROI(before_Image, mouth_before);

	// wb_̍쐬ƃf[^̈̊m
	mouthImage_gray = cvCreateImage(cvSize(mouth.width, mouth.height), IPL_DEPTH_8U, 1);
	before_mouthImage_gray = cvCreateImage(cvSize(mouth_before.width, mouth_before.height), IPL_DEPTH_8U, 1);

	// 摜̃O[XP[
	cvCvtColor(capture_Image, mouthImage_gray, CV_BGR2GRAY);
	cvCvtColor(before_Image, before_mouthImage_gray, CV_BGR2GRAY);

	// ق̉摜ɍ킹
	if(mouth.width * mouth.height < mouth_before.width * mouth_before.height){
		// wb_̍쐬ƃf[^̈̊m
		mouthImage_gray2 = cvCreateImage(cvSize(mouth.width, mouth.height), IPL_DEPTH_8U, 1);
		before_mouthImage_gray2 = cvCreateImage(cvSize(mouth.width, mouth.height), IPL_DEPTH_8U, 1);

		// 摜̃Rs[
		cvCopy(mouthImage_gray, mouthImage_gray2, NULL);
		// oCL[rbN@ɂ鍂𑜓x
		cvResize(before_mouthImage_gray, before_mouthImage_gray2, CV_INTER_CUBIC);

	}else{
		// wb_̍쐬ƃf[^̈̊m
		mouthImage_gray2 = cvCreateImage(cvSize(mouth_before.width, mouth_before.height), IPL_DEPTH_8U, 1);
		before_mouthImage_gray2 = cvCreateImage(cvSize(mouth_before.width, mouth_before.height), IPL_DEPTH_8U, 1);

		// 摜̃Rs[
		cvCopy(before_mouthImage_gray, before_mouthImage_gray2, NULL);
		// oCL[rbN@ɂ鍂𑜓x
		cvResize(mouthImage_gray, mouthImage_gray2, CV_INTER_CUBIC);
	}

	// qXgŐψꉻ
	cvEqualizeHist(mouthImage_gray2, mouthImage_gray2);
	cvEqualizeHist(before_mouthImage_gray2, before_mouthImage_gray2);

	// ΒlaZo
	for (y = 0 ; y < mouthImage_gray2->height ; y++) {
		for (x = 0 ; x < mouthImage_gray2->width ; x++) {
			sad[0] += abs(mouthImage_gray2->imageData[mouthImage_gray2->widthStep * y + x] -
				before_mouthImage_gray2->imageData[before_mouthImage_gray2->widthStep * y + x]);
		}
	}

	sad[0] /= (mouthImage_gray2->height * mouthImage_gray2->width); // Ki摜TCYŊj

	cvResetImageROI(capture_Image); // ROÏ̉
	cvResetImageROI(before_Image);
}

// f̕בւ
void UE::sort_Data(void)
{
	for(int i=10;i>0;i--){
		of[i]=of[i-1];
		sad[i]=sad[i-1];
	}
	of[0]=0.0;
	sad[0]=0.0;
}

// SVMɂ锭b茋ʂԂ
bool UE::SVM(void)
{
	svm = -0.8476 * of[10] - 0.2357 * of[9] - 0.213 * of[8] + 0.2002 * of[7] + 0.8841 * of[6]
		+ 1.596 * of[5] + 1.892 * of[4] + 2.9368 * of[3] + 3.0423 * of[2] + 3.2996 * of[1] + 3.4326 * of[0]
		+ 0.0081 * sad[10] + 0.0068 * sad[9] + 0.0074 * sad[8] + 0.0043 * sad[7] + 0.0069 * sad[6]
		+ 0.0075 * sad[5] + 0.008 * sad[4] + 0.0059 * sad[3] + 0.01 * sad[2] + 0.0116 * sad[1] + 0.0178 * sad[0]
		- 8.9252;

	if(svm>0){
		return true;
	}

	return false;
}
